> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cedarai.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List customers

> Retrieves a list of customers for the specified carrier.



## OpenAPI

````yaml /user-docs/api-reference/external-openapi.json post /ims/customers
openapi: 3.1.0
info:
  title: ARMS External API
  version: 1.0.0
  description: >-
    OpenAPI specification generated from external API schemas. Endpoints require
    query parameter carrierId and headers x-arms-api-key and x-arms-assume-user.
  license:
    name: Proprietary
    url: https://cedarai.com
servers:
  - url: https://api-lg.arms.cedarai.com
    description: Production (US)
  - url: https://api-lg.arms.cedarai.se
    description: Production (EU)
security:
  - ApiKeyAuth: []
    AssumeUser: []
paths:
  /ims/customers:
    post:
      summary: List customers
      description: Retrieves a list of customers for the specified carrier.
      operationId: listCustomers
      parameters:
        - $ref: '#/components/parameters/CarrierId'
        - $ref: '#/components/parameters/ViewAsUserGroup'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ListCustomersInput'
            examples:
              basic:
                summary: List all customers
                value:
                  carrierId: 1234
              filterByIds:
                summary: Filter by customer IDs
                value:
                  carrierId: 1234
                  customerIds:
                    - 100
                    - 200
                    - 300
              includeShippers:
                summary: Include shipper customers
                value:
                  carrierId: 1234
                  includeShipperCustomers: true
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListCustomersOutput'
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
        '500':
          description: Internal Server Error
        default:
          description: Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
components:
  parameters:
    CarrierId:
      name: carrierId
      in: query
      required: true
      schema:
        type: integer
      description: Carrier identifier; required for all endpoints
    ViewAsUserGroup:
      name: viewAsUserGroup
      in: query
      required: false
      schema:
        type: string
      description: Optional user group context
  schemas:
    ListCustomersInput:
      type: object
      required:
        - carrierId
      properties:
        carrierId:
          type: integer
          description: Carrier identifier. May also be supplied via query parameter.
        customerIds:
          type: array
          items:
            type: integer
          description: Optional filter by specific customer IDs
        customerUuids:
          type: array
          items:
            type: string
          description: Optional filter by specific customer UUIDs
        includeShipperCustomers:
          type: boolean
          description: Whether to include shipper customers
          default: false
    ListCustomersOutput:
      type: object
      properties:
        customers:
          type: array
          items:
            $ref: '#/components/schemas/CustomerOutput'
        contract:
          type: object
          properties:
            effect:
              type: string
              enum:
                - overwrite
            resourceType:
              type: string
              enum:
                - Customer
    Error:
      type: object
      properties:
        message:
          type: string
    CustomerOutput:
      type: object
      properties:
        resourceId:
          type: integer
        uuid:
          type: string
        name:
          type: string
        carrierId:
          type: integer
        carrier:
          $ref: '#/components/schemas/CarrierResource'
        blockCodePrefix:
          type: string
        locations:
          type: array
          items:
            $ref: '#/components/schemas/CustomerLocationResource'
        scac:
          type: string
        printedName:
          type: string
    CarrierResource:
      type: object
      properties:
        resourceType:
          type: string
          enum:
            - Carrier
        resourceId:
          type: integer
        uuid:
          type: string
          description: UUID that complements the legacy numeric resourceId.
        carrierCode:
          type: string
        name:
          type: string
    CustomerLocationResource:
      type: object
      properties:
        resourceId:
          type: integer
        uuid:
          type: string
        name:
          type: string
        blockCode:
          type: string
        customerBlock:
          $ref: '#/components/schemas/GroupingResource'
        customer:
          $ref: '#/components/schemas/CustomerResource'
        carrier:
          $ref: '#/components/schemas/CarrierResource'
        groupings:
          type: array
          items:
            $ref: '#/components/schemas/GroupingResource'
        abbreviatedName:
          type: string
        currencyCode:
          type: string
    GroupingResource:
      type: object
      properties:
        resourceType:
          type: string
          enum:
            - Grouping
        resourceId:
          type: integer
        uuid:
          type: string
          description: UUID that complements the legacy numeric resourceId.
        name:
          type: string
        groupingType:
          type: string
        sortOrder:
          type: integer
        colorToken:
          type: string
    CustomerResource:
      type: object
      properties:
        resourceType:
          type: string
          enum:
            - Customer
        resourceId:
          type: integer
        uuid:
          type: string
          description: UUID that complements the legacy numeric resourceId.
        name:
          type: string
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-arms-api-key
      description: Your ARMS API key
    AssumeUser:
      type: apiKey
      in: header
      name: x-arms-assume-user
      description: Email of a user assigned to the appropriate user group

````